package cn.iocoder.yudao.module.mes.service.stockindetail;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;

import javax.annotation.Resource;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.stockindetail.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.stockindetail.StockInDetailDO;
import cn.iocoder.yudao.module.mes.dal.mysql.stockindetail.StockInDetailMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import javax.annotation.Resource;
import org.springframework.context.annotation.Import;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link StockInDetailServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(StockInDetailServiceImpl.class)
public class StockInDetailServiceImplTest extends BaseDbUnitTest {

    @Resource
    private StockInDetailServiceImpl stockInDetailService;

    @Resource
    private StockInDetailMapper stockInDetailMapper;

    @Test
    public void testCreateStockInDetail_success() {
        // 准备参数
        StockInDetailSaveReqVO createReqVO = randomPojo(StockInDetailSaveReqVO.class).setId(null);

        // 调用
        Long stockInDetailId = stockInDetailService.createStockInDetail(createReqVO);
        // 断言
        assertNotNull(stockInDetailId);
        // 校验记录的属性是否正确
        StockInDetailDO stockInDetail = stockInDetailMapper.selectById(stockInDetailId);
        assertPojoEquals(createReqVO, stockInDetail, "id");
    }

    @Test
    public void testUpdateStockInDetail_success() {
        // mock 数据
        StockInDetailDO dbStockInDetail = randomPojo(StockInDetailDO.class);
        stockInDetailMapper.insert(dbStockInDetail);// @Sql: 先插入出一条存在的数据
        // 准备参数
        StockInDetailSaveReqVO updateReqVO = randomPojo(StockInDetailSaveReqVO.class, o -> {
            o.setId(dbStockInDetail.getId()); // 设置更新的 ID
        });

        // 调用
        stockInDetailService.updateStockInDetail(updateReqVO);
        // 校验是否更新正确
        StockInDetailDO stockInDetail = stockInDetailMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, stockInDetail);
    }

    @Test
    public void testUpdateStockInDetail_notExists() {
        // 准备参数
        StockInDetailSaveReqVO updateReqVO = randomPojo(StockInDetailSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> stockInDetailService.updateStockInDetail(updateReqVO), STOCK_IN_DETAIL_NOT_EXISTS);
    }

    @Test
    public void testDeleteStockInDetail_success() {
        // mock 数据
        StockInDetailDO dbStockInDetail = randomPojo(StockInDetailDO.class);
        stockInDetailMapper.insert(dbStockInDetail);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbStockInDetail.getId();

        // 调用
        stockInDetailService.deleteStockInDetail(id);
       // 校验数据不存在了
       assertNull(stockInDetailMapper.selectById(id));
    }

    @Test
    public void testDeleteStockInDetail_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> stockInDetailService.deleteStockInDetail(id), STOCK_IN_DETAIL_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetStockInDetailPage() {
       // mock 数据
       StockInDetailDO dbStockInDetail = randomPojo(StockInDetailDO.class, o -> { // 等会查询到
           o.setStockInId(null);
           o.setStockInNo(null);
           o.setStockInItemId(null);
           o.setPlanId(null);
           o.setProductId(null);
           o.setNumber(null);
           o.setCreateTime(null);
       });
       stockInDetailMapper.insert(dbStockInDetail);
       // 测试 stockInId 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setStockInId(null)));
       // 测试 stockInNo 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setStockInNo(null)));
       // 测试 stockInItemId 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setStockInItemId(null)));
       // 测试 planId 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setPlanId(null)));
       // 测试 productId 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setProductId(null)));
       // 测试 number 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setNumber(null)));
       // 测试 createTime 不匹配
       stockInDetailMapper.insert(cloneIgnoreId(dbStockInDetail, o -> o.setCreateTime(null)));
       // 准备参数
       StockInDetailPageReqVO reqVO = new StockInDetailPageReqVO();
       reqVO.setStockInId(null);
       reqVO.setStockInNo(null);
       reqVO.setStockInItemId(null);
       reqVO.setPlanId(null);
       reqVO.setProductId(null);
       reqVO.setNumber(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<StockInDetailDO> pageResult = stockInDetailService.getStockInDetailPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbStockInDetail, pageResult.getList().get(0));
    }

}